#ifndef MCMC_CK
#define MCMC_CK

#include "RNP2to191.h"

using namespace rnp2to191;

namespace mcmc_spc {
	

//

//            OpNX^

//

ref class myexcept: Exception {
       public:
			String ^ vsc;
			int StateID;
		    myexcept( String ^ sc ): vsc(sc), StateID(0) { }
			myexcept( int iv ): vsc( "" ), StateID(iv) { }
			myexcept( String ^ sc, int iv ): vsc(sc), StateID(iv) { }
		    virtual ~myexcept() {}
			!myexcept() {}
		    String ^ what() { return vsc; }          
};


	
	double sqr( double x );

	double scale_sgm( double acpt_r, int & ck );

	double myLog( double v );

	double myExp( double v );
	

	ref class MCMC {
		public:
			RNP2to191 * rn;

			String ^ mcmcID;
			int NSimu, p, n;

			double ** X;
			double ** paramB;
			int * countB;
			double * sgmB;
			double * Frc, * LogFrcFac;

			MCMC(){ }
			virtual ~MCMC(){ ClearMe(); }
			!MCMC(){ ClearMe(); }

			void ClearMe();

			virtual void Init( int vNSimu, String ^ vmcmcID, RNP2to191 * vrn, int vn, int vp, double * vFrc, double ** vX, double * vsgmB, double * initB );
						

			double LogL( double * tempB ); 

			virtual void do_mcmc();
	};

		
	//
	//								Quick Sort
	//
	//      S. Kawai (1988).  Methods of programming (in Japanese). Tokyo: Iwanami-shoten.
	//		S. Ishihata (1989). Algorithms and Data Structure (in Japanese). Tokyo:Iwanami-shoten
	//
	void qSort( double * d, int Lb, int Ub );


}

#endif